package arsd;
#-----------------------------------------------
# 人工無脳 ARtificial Spirit - D型 実験機No.1
#
# 2015-4-6 ver 1.0

use utf8;
use feature 'unicode_strings';
use open ':encoding(utf8)';         # I/O default encoding is UTF-8
use open ':std';                    # stdio encoding = utf8
use Encode qw(encode_utf8 decode);
use Fcntl;
use strict;

#------------------- ユーザー設定 ----------------------

$arsd::ARSLog="arsd_log.txt"; #ARSのログ
$arsd::ARSLogLength=500;      #ARSログの長さ
$arsd::IsFlockEnable =0;

#-------------------------------------------------------

%arsd::Main=();        # 主辞書
@arsd::MainKeys=();    # 主辞書のキー

#-------------------------------------------------------

BEGIN {	srand; }

#-------------------------------------------------

# M E T H O D 

#-------------------------------------------------


sub arsd::ReplyTo
{
	if($arsd::Main{'$Queue$'} ne '')
	{ 
		my $queue=$arsd::Main{'$Queue$'};
		$arsd::Main{'$Queue$'}='';
		
		&arsd::writeLog("$arsd::Main{'$MyName$'},$queue (queue),");
		return &arsd::develop($queue);
	}
	
	my $input=shift;
	foreach ($input)
	{
		s/($arsd::Main{'$MyName$'}(さん|君|)|あなた|君)/%ars%/g;
		s/(私|わたし|あたし|僕|ぼく|俺|$arsd::Main{'$UserName$'})/%user%/g;
		s/,/&#2C;/g;
		s/\$/&#24;/g;
	}
	
	foreach my $key (@arsd::MainKeys)
	{
		if($input =~ /$key/)
		{
			$arsd::Main{'$1$'}= $1 if ($1);
			$arsd::Main{'$2$'}= $2 if ($2);
			&arsd::writeLog("$arsd::Main{'$MyName$'},$key,$input");
			return &arsd::develop($key);
		}
	}
	
	&arsd::writeLog("$arsd::Main{'$MyName$'},\$NotFound\$,$input");
	return &arsd::develop('$NotFound$');
}

sub arsd::Load
{
	my $path = shift;
	
	sysopen(FILE,$path,O_RDONLY) or die("arsd: $path not found");
	
	while (<FILE>)
	{
		/^#/ && do { next; };
		/^([^ ]+) ([^\n\r]+)/ && do{$arsd::Main{$1}=$2; push @arsd::MainKeys,$1;};
	}
	close FILE;
}

sub arsd::GetARSName{ return $arsd::Main{'$MyName$'}; }
sub arsd::SetUserName {	$arsd::Main{'$UserName$'} = shift; }
sub arsd::SetQueue { $arsd::Main{'$Queue$'}=shift || ""; return ""; }
sub arsd::GetQueue { return $arsd::Main{'$Queue$'}; }


#---------------------------------------
# I N T E R N A L  F U N C T I O N S
#

sub arsd::develop
{
	my $key=shift;
	my @vals=split(/,/,$arsd::Main{$key});

	foreach($vals[rand(1+$#vals)])
	{
		s/\%month\%/&arsd::getMonth()/eg;
		s/\%hour\%/&arsd::getHour()/eg;
		s/\%queue ([^\n]+)\%/&arsd::SetQueue($1)/eg;
		s/(\$[^ \$]+\$)/&arsd::develop($1)/eg;

		return undef if(/^%nop%/);
		return $_;
	}
}



sub arsd::writeLog
{
	my $line=shift;
	sysopen (LOG,$arsd::ARSLog, O_RDWR | O_CREAT) || die("arsd: $arsd::ARSLog not found");
	if($arsd::IsFlockEnable)
	{
		flock (LOG,2) or return "arsd: flock() not available - let IsFlockEnable=0.";
	}
	my @log=<LOG>;
	my $stamp= &arsd::getTimestamp();
	
	push @log,"$stamp,$line\n";
	splice @log,$arsd::ARSLogLength;
	seek LOG,0,0;
	print LOG @log;
	truncate LOG,tell(LOG);
	close LOG;

}

sub arsd::getTimestamp
{
	my ($sec, $min, $hour, $day, $mon, $year, $weekday) = localtime(time);
	
	return sprintf("%04d-%02d-%02d %02d:%02d:%02d",
		1900+$year,++$mon,$day,$hour,$min,$sec);
}

sub arsd::getMonth
{
	my ($sec, $min, $hour, $day, $mon, $year, $weekday) = localtime(time);
	
	return ++$mon;
}

sub arsd::getHour
{
	my ($sec, $min, $hour, $day, $mon, $year, $weekday) = localtime(time);
	
	return $hour;
}

1;

