#!/usr/bin/perl
#-------------------------
# 人工無脳chatCGI 2015
#

# 2015-4-6 ver 1.0 
# written by 加藤真一(人工無脳は考える)

use utf8;
use open ':encoding(utf8)';         # I/O default encoding is UTF-8
use open ':std';                    # stdio encoding = utf8
use Encode qw(encode decode);
use Fcntl;

#------------------------------ CGI設定 --------------------------------

$LogFile = './arsd_log.txt'; # ログファイル名
$DicFile=  './exp1-dic.txt'; # 辞書ファイル名
$DisplayLength = 8;          # 表示行数
$IsFlockEnable =0;           # flock()が効かないとき0

#-----------------------------------------------------------------------
#
# データの格納：二次元配列
# [0]                  [1]            [2]                      [3]
# yyyy-mm-dd hh:mm:ss  人工無脳の名前 人工無脳の返答(expand前) ユーザの入力

@Log=(); 
%Freq=();

&load;
&RenderFrequentAnswer;

sub RenderFrequentAnswer
{
	print "<TABLE>\n";
	foreach(sort {$Freq{$b} <=> $Freq{$a}} keys %Freq)
	{
		my $ratio=$Freq{$_}/
		print "<TR><TD>$Freq{$_}</TD><TD>$_</TD></TR>\n";
	}
	print "</TABLE>\n";
}


sub load
{
	if($#Log == -1)
	{
		sysopen (LOG,$LogFile,O_RDONLY) || print "$LogFile が開けません";
		while(my $line=<LOG>)
		{
			chomp $line;
			my @items = split /,/,$line;
			
			push @Log, [@items];
			$Freq{$items[2]}++;
			
		}
		close(LOG);
	}
}
