#!/usr/local/bin/perl
#-------------------------
# 人工無脳chatCGI 2015
#

# 2015-4-6 ver 1.0 
# written by 加藤真一(人工無脳は考える)

use utf8;
use open ':encoding(utf8)';         # I/O default encoding is UTF-8
use open ':std';                    # stdio encoding = utf8
use Encode qw(encode decode);
use Fcntl;

use arsd;                           # 人工無脳


#------------------------------ CGI設定 --------------------------------

$LogFile = './chat_log.txt'; # ログファイル名
$DisplayLength = 8;          # 表示行数
$RecordLength  =100;         # 保持行数
$URLThis       ='chat.cgi';  # このCGIのパス
$DefaultName   ='';          # ユーザのデフォルト名
$CookieExpires =120;         # クッキー有効期間,日
$ReplyDelay    =800;         # 【演出】人工無脳返答の表示遅延時間, msec
$IsFlockEnable =0;           # flock()が効かないとき0
 
#---------------------------- 人工無脳設定 -----------------------------

@MunoDic=("exp1-dic.txt","exp2-dic.txt");

&arsd::Load($MunoDic[&get_muno_id()]); # 辞書の読み込み

#-----------------------------------------------------------------------

%Form=();
%Cookie=();
@Log=();

#-----------------
# M A I N 
#

&load_cookie();
&load_form();


#-------
#コンソールテスト用のダミーデータ
if(!defined($ENV{'REQUEST_METHOD'}))
{
	$Form{'name'}="test"; 
	$Form{'text'}="queue"; 
	$Form{'phase'}='write'; 
	$Form{'queue'}="queue";
}
#ここまで
#----------

if($Form{'phase'} eq 'write')
{
	&OnWrite;
}
else
{
	&OnCreate;
}

exit 0;

#---------------------
# O N C R E A T E
#

sub OnCreate
{
	&Render_Chat();
}

#---------------------
# O N W R I T E
#

sub OnWrite
{
	$Cookie{'name'}= defined $Form{'name'} ? $Form{'name'} : $DefaultName;
	
	#---------------------------
	#  ARS extension
	
	&arsd::SetUserName($Form{'name'});
	&arsd::SetQueue($Form{'queue'});
	
	my $ArsName  =&arsd::GetARSName();
	my $ArsReply =&arsd::ReplyTo($Form{'text'});

	$Form{'queue'} = &arsd::GetQueue();	

	#---------------------------
	
	sysopen (LOG,$LogFile, O_RDWR | O_CREAT) || &Die("$LogFile not found");
	
	if($IsFlockEnable)
	{
		flock (LOG,2) or &Die("flock() not available - let IsFlockEnable=0.");
	}
	seek LOG,0,0;
	@Log=<LOG>;
	my $stamp=&get_timestamp;
	push @Log, "1$Form{'name'}：$Form{'text'} <SMALL>$stamp</SMALL>\n";
	push @Log, "0$ArsName：$ArsReply <SMALL>$stamp</SMALL>\n" if (defined $ArsReply);
	
	splice @Log,0,($#Log>$RecordLength ? $#Log-$RecordLength : 0);
	seek LOG,0,0;
	print LOG @Log;
	truncate LOG,tell(LOG);
	close LOG;
	
	&Render_Chat;
	
}

#--------------------------
# R E N D E R _ C H A T
#

sub Render_Chat
{
	&render_cookie;

	if($#Log == -1)
	{
		sysopen (LOG,$LogFile,O_RDONLY) || print "$LogFile が開けません";
		@Log=<LOG>; 
		close(LOG);
	}
	
	splice @Log,0,($#Log>$DisplayLength ? $#Log-$DisplayLength : 0);
	
	#最新が人工無脳発言の場合、表示にディレイをかける
	
	my $timeout="";
	my $scrollToBottom="window.scrollTo(0,(document.body.scrollHeight || document.documentElement.scrollHeight))";
	my $css=$arsd::Main{'$ExtCSS$'};
	if($Form{'phase'} eq 'write')
	{
		$timeout="setTimeout( function() {".
			"document.getElementById('ars').style.display='';".
			"$scrollToBottom;}".
			",$ReplyDelay)";

	}
	print "Content-Type: text/html; charset=utf-8\n\n<HTML><HEAD><TITLE>";
	print $arsd::Main{'$BrowserTitle$'};
	print "</TITLE><LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"$css\">\n";
	print "</HEAD><BODY OnLoad=\" $scrollToBottom; document.Form.Text.focus(); $timeout; \">\n";

	my $last=pop @Log;
	
	foreach (@Log)
	{
		if(s/^0//){
			print "<DIV class=\"lballoon\"><P class=\"lchild\">$_</P></DIV>";
		}
		elsif(s/^1//){
			print "<DIV class=\"rballoon\"><P class=\"rchild\">$_</P></DIV>";
		}
	}
	foreach ($last)
	{
		if(s/^0//){
			print "<DIV class=\"lballoon\" id=\"ars\" style=\"display: none\"><P class=\"lchild\">$_</P></DIV>";
		}
		elsif(s/^1//){
			print "<DIV class=\"rballoon\"><P class=\"rchild\">$_</P></DIV>";
		}
	}

	print <<"EOQ";


<FORM NAME="Form" ACTION="$URLThis" METHOD="POST">
<TABLE class="console"><TR><TD width="10%">Name: </TD><TD width="90%">
<INPUT TYPE=TEXT NAME=name SIZE=20 VALUE="$Cookie{'name'}"></TD></TR>
<TR><TD>Text:</TD><TD>
<INPUT TYPE=TEXT NAME=text ID="Text" style="width:100%;"></TD></TR>
<TR><TD> <BR></TD><TD><INPUT TYPE=SUBMIT VALUE="   OK   "></TABLE>
<INPUT TYPE=hidden NAME="phase" VALUE="write">
<INPUT TYPE=hidden NAME="queue" VALUE="$Form{'queue'}">

</FORM>	</DIV></BODY></HTML>

EOQ

}

sub get_timestamp
{
	my ($sec, $min, $hour, $day, $mon, $year, $weekday) = localtime(time);
	
	return sprintf("%04d-%02d-%02d %02d:%02d:%02d;",
		1900+$year,++$mon,$day,$hour,$min,$sec);
}


#--------------------------
# form-cookie I/O
#

sub load_form
{
	my $query;
	if($ENV{'REQUEST_METHOD'} =~ /post/i)
	{
		read(STDIN, $query, $ENV{'CONTENT_LENGTH'}); 
	}
	else { 
	  $query = $ENV{'QUERY_STRING'}; 
	} 

	foreach ( split(/&/, $query) )
	{
		my ($key, $val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('H2', $1)/eg;
		$val=decode('UTF-8',$val);
		
	    # CGIで使う文字のエスケープ
		$val =~ s/"/&quot;/g;
		$val =~ s/</&lt;/g;
		$val =~ s/>/&gt;/g;
		$val =~ s/,/&#044;/g;

		$Form{$key} = $val;

	}
}


sub load_cookie
{
	foreach (split(/;/, $ENV{'HTTP_COOKIE'})) 
	{
	    my ($key, $val) = split(/=/);
	    $val =~ tr/+/ /;   
	    $val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('H2', $1)/eg;
	    $key =~ tr/+/ /;
	    $key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('H2', $1)/eg;
	    
	    $Cookie{$key} = decode('UTF-8',$val);
	}
}

sub render_cookie
{
	my $exp =&get_expire_date($CookieExpires);
	
	while(my ($key,$val) = each(%Cookie))
	{
		$key =  encode('utf-8',$key);
		$key =~ s/(\W)/'%'.unpack('H2', $1)/eg;	
		$key =~ tr/ /+/;
		$val = encode('utf-8',$val);
		$val =~ s/(\W)/'%'.unpack('H2', $1)/eg;	
		$val =~ tr/ /+/;
		print "Set-Cookie: $key=$val; expires=$exp\n";
	}
}

sub get_expire_date
{
	my $exp=shift;	#期間, 日
	my @mstr=qw /Jan Feb Mar Apr May Jun Jul Aug Sep Nov Dec/;
	my @wstr=qw /Sun Mon Tue Wed Thu Fri Sat/;
	my ($sec, $min, $hour, $day, $mon, $year, $weekday) 
		= gmtime(time + $exp * 24 * 60 * 60);
	
	return sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT;",
		$wstr[$weekday],$day,$mstr[$mon],$year+1900,$hour,$min,$sec);
}

sub get_muno_id
{
	return 0 if !defined $ENV{'PATH_INFO'};
	
	$ENV{'PATH_INFO'} =~ /(\d+)/;
	return 0 if ($1>$#MunoDic);
	return $1;
}

sub Die
{
	print "<P>chat.cgi: $_</P>";
	exit 0;
}
